#include "Queue.h"

Queue *createQueue() {
	Queue *queue;
	queue = (Queue *)malloc(sizeof(Queue));
	queue->count = 0;
	queue->front = 0;
	queue->rear = 0;
	return queue;
}

// implement this
int enqueue(Queue *queue, char *cmd) {
	if (queue->count >= MSG_QUEUE_DEPTH) {
		printf("enqueue: Queue depth exceeded\n");
		return 0;
	}
	memcpy(queue->cmdList[queue->rear], cmd, YY_BUF_SIZE);
	queue->rear = (queue->rear+1)%MSG_QUEUE_DEPTH;
	queue->count++;
	return 1;
}

// implement this
int dequeue(Queue *queue, char *cmd) {
	if (queue->count <= 0) {
		printf("dequeue: The queue is empty\n");
		return 0;
	}
	memcpy(cmd, queue->cmdList[queue->front], YY_BUF_SIZE);
	queue->front = (queue->front+1)%MSG_QUEUE_DEPTH;
	queue->count--;
	return 1;
}

int getQueueCount(Queue *queue) {
	return (queue->count);
}
